{
  inheritance :
  When we hear IS A ... we have inheritance
  Woman Is A Human. (Human Is NOT always a woman !!!)
  Worker IS A Employee. (Employee IS NOT always a worker !!!)
  In C++ in Worker.h : class Worker : public Employee ...
  In Delphi in Worker.pas : TWorker = class(TEmployee)...

In summary :
OVERLOAD : put it in methods. Redeclare same name of function with different arguments in the same class
VIRTUAL : put in on Fathers (root) method that can be overriden by its childs
OVERRIDE : put it on Childs method that must redeclare fathers virtual method (Redeclare same name of function with the same arguments in different classes)
INHERITED : put it on Child to invoke fathers method ex : inherited Create(Name_,Surname_)
}

unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls,
  Employee, //I have employees (fathers)
  Worker,   //I have workers (childs)
  WorkerPartTime;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonAddWorkerPartTime: TButton;
    ButtonShowAlEmployeesVirtual: TButton;
    ButtonDestroyAllEmployees: TButton;
    ButtonAddWorker: TButton;
    ButtonShowAllWorkers: TButton;
    ButtonAddEmployee: TButton;
    ButtonShowEmployees: TButton;
    EditWorkerPartTimeNameNew: TEdit;
    EditWorkerPartTimeSurnameNew: TEdit;
    EditWorkerWorkingPartTimeHoursNew: TEdit;
    EditWorkerWorkingPartTimeDaysNew: TEdit;
    EditWorkerNameNew: TEdit;
    EditWorkerSurnameNew: TEdit;
    EditWorkerWorkingHoursNew: TEdit;
    EditEmployeeNameNew: TEdit;
    EditEmployeeSurnameNew: TEdit;
    GroupBoxNewWorkerPartTime: TGroupBox;
    GroupBoxNewWorker: TGroupBox;
    GroupBoxNewEmployee: TGroupBox;
    LabelWorkerPartTimeName: TLabel;
    LabelWorkerPartTimeSurname: TLabel;
    LabelWorkerPartTimeWorkingDays: TLabel;
    LabelWorkerPartTimeWorkingHours: TLabel;
    LabelWorkerSurname: TLabel;
    LabelWorkerName: TLabel;
    LabelEmployeeName: TLabel;
    LabelEmployeeSurname: TLabel;
    LabelWorkerWorkingHours: TLabel;
    Memo: TMemo;
    procedure ButtonAddEmployeeClick(Sender: TObject);
    procedure ButtonAddWorkerClick(Sender: TObject);
    procedure ButtonAddWorkerPartTimeClick(Sender: TObject);
    procedure ButtonDestroyAllEmployeesClick(Sender: TObject);
    procedure ButtonShowAlEmployeesVirtualClick(Sender: TObject);
    procedure ButtonShowAllWorkersAsEmployeesVirtualClick(Sender: TObject);
    procedure ButtonShowEmployeesClick(Sender: TObject);
    procedure ButtonShowAllWorkersClick(Sender: TObject);


    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);




  private
    { private declarations }



  public
    { public declarations }
    EmployeeList : TList; //list of objects of TEmployee (... But TWorker IS TEmployee !)
    //This is a POLYMORFIC List !!! Has TEmployee and TWorker objects
    //The polimorfic containers ALWAYS have the FATHER as main object.
    //takes eployees,workers,workers part time
  end; 

var
  Form1: TForm1;

implementation


{ TForm1 }



//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
///////////////////////////EVENTS/////////////////////////////////////////////

//add a new employee
procedure TForm1.ButtonAddEmployeeClick(Sender: TObject);
var Emp_Obj : TEmployee;
begin

   //CREATE A NEW EMPLOYEE OBJECT
   Emp_Obj := TEmployee.Create(EditEmployeeNameNew.Text,EditEmployeeSurnameNew.Text);

   self.EmployeeList.Add(Emp_Obj);

end;

//add a new worker
procedure TForm1.ButtonAddWorkerClick(Sender: TObject);
var Work_Obj : TWorker;
begin

   //CREATE A NEW WORKER OBJECT
   Work_Obj := TWorker.Create(EditWorkerNameNew.Text,EditWorkerSurnameNew.Text,strtoint(EditWorkerWorkingHoursNew.Text));

   self.EmployeeList.Add(Work_Obj); //Worker IS an Employee too !!!

end;

//add a new workerparttime
procedure TForm1.ButtonAddWorkerPartTimeClick(Sender: TObject);
begin
   EmployeeList.Add( TWorkerPartTime.Create ( EditWorkerPartTimeNameNew.Text,
                                              EditWorkerPartTimeSurnameNew.Text,
                                              strtoint(EditWorkerWorkingPartTimeHoursNew.Text),
                                              strtoint(EditWorkerWorkingPartTimeDaysNew.Text)
                                             ) );
end;






//show all employees
procedure TForm1.ButtonShowEmployeesClick(Sender: TObject);
 var i,imax:integer;
begin
  memo.Clear;

  imax:=TEmployee.CountEmployees - 1; //INVOICE CLASS METHOD !!!

  for i:=0 to imax do begin
    Memo.Lines.Add(TEmployee(EmployeeList.Items[i]).PrintMe); //Stamp all the polymorfic array as TEmployee
  end;

end;

 //show all employees virtual way
 //This is the best way !!!
procedure TForm1.ButtonShowAlEmployeesVirtualClick(Sender: TObject);
 var i,imax:integer;
begin
  memo.Clear;

  imax:=TEmployee.CountEmployees - 1; //INVOICE CLASS METHOD !!!

  for i:=0 to imax do begin
    Memo.Lines.Add(TEmployee(EmployeeList.Items[i]).PrintMeVirtual);  //Stamp all the polymorfic array as TEmployee or TWorker
    //PrintMeVirtual has OVERRIDE If you remove override will print everything like TEmployee (same with print)
  end;
end;

procedure TForm1.ButtonShowAllWorkersAsEmployeesVirtualClick(Sender: TObject);
 var i,imax:integer;
begin
  memo.Clear;

  imax:=TEmployee.CountEmployees - 1; //INVOICE CLASS METHOD !!!

  for i:=0 to imax do begin
    if TEmployee(EmployeeList.Items[i]) is TWorker then begin
      Memo.Lines.Add( (TWorker(EmployeeList.Items[i]) as TEmployee).PrintMeVirtual );  //Stamp all the polymorfic array as TEmployee or TWorker
      //PrintMeVirtual has OVERRIDE If you remove override will print everything like TEmployee (same with print)


    end;
  end;

end;

//show all workers
procedure TForm1.ButtonShowAllWorkersClick(Sender: TObject);
var i,imax : integer;
begin
  memo.Clear;

  imax:=TEmployee.CountEmployees - 1; //INVOICE CLASS METHOD !!!

  for i:=0 to imax do begin
    if TEmployee(EmployeeList.Items[i]) is TWorker then begin  //From all my employees print only my workers !!!
       //Memo.Lines.Add(TWorker(EmployeeList.Items[i]).PrintMe); //Cast as TWorker since it IS a Worker

       //try and this one !!!
       Memo.Lines.Add(TWorker(EmployeeList.Items[i]).PrintMeVirtual);
    end;
  end;

end;


//Destroy all Employees
procedure TForm1.ButtonDestroyAllEmployeesClick(Sender: TObject);
var i,imax : integer;
begin

  imax:=TEmployee.CountEmployees - 1; //INVOICE CLASS METHOD !!!
  for i:=imax downto 0 do begin
    TEmployee(EmployeeList.Items[i]).Destroy; //If it is a worked Destroy both worker first and employee next !!!
                                              //Destroy has OVERRIDE !!! if you remove override only TEmployee will be deleted (not the worker)
    self.EmployeeList.Delete(i);
  end;
end;






//On create form
procedure TForm1.FormCreate(Sender: TObject);
begin
  EmployeeList := TList.Create; //Create the employee list !!!
end;

//On Exit form
procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  EmployeeList.Free;  //Destroy the employee list !!!
end;



initialization
  {$I unit1.lrs}

end.

